10 DIM pin_dat(20):CLS: PRINT"DM/MM I/O Line Tester.   by Mick Gulovsen Jan 2012"
20 Print:Print"This simple test program will test the most common"
25 Print"features of the 20 pin GPIO header as used on the"
26 Print"Maximite/Duinomite family of Pic32 mini computers."
30 Print:Print"This program assumes that a suitable test board is"
32 Print"connected, such as the Test-A-Mite. Available from":Print"(www.dontronics-shop.com/test-a-mite-letter.html)"
40 Print: Print"Whilst this program works on both the Maximite and"
45 Print"the Duinomite, they each use different pins for":Print"Frequency, Period and Count inputs."
46 print:Print"   Which platform are we going to test?"
50 Print:Print"Select  M for Maximite  OR  D for Duinomite ";
60 A$=inkey$:If A$="" then goto 60
70 If A$="D" then goto 105 else If A$="d" then goto 105 ' Duinomite Selected
80 If A$="M" then goto 106 else If A$="m" then goto 106' Maximite Selected
90 goto 60 ' Invalid key pressed
105 Duino=1 : goto 110
106 Duino=0

 


110 ' Main Menu
115 FOR pin_no=1 TO 20 : SETPIN pin_no,8 :PIN(pin_no)=0 : NEXT pin_no
120 CLS:Print"           ";
130 if Duino=0 then Print "MAXIMITE Tests" else Print "DUINOMITE Tests"
140 If Duino=1 then SDDISABLE ' Disable SD Card Access to free up Pin(5), (6) and (7) as GPIO
150 Print:Print"Please Select your Test":print:Print
160 Print"A - Analog Input Test    D - Digital I/O Test"
170 Print"C - Count  Input Test    F - Frequency Input Test"
180 Print"P - Period Input Test ":print
190 Print"          Fun with LEDs tests"
200 Print
210 Print"S - Simple LED Chase     B - Binary LED Count"
220 Print"G - Bar Graph Display    L - LED Crossover":Print:Print"         I - Information about Test-A-Mite":Print
230 A$=inkey$:If A$="" then goto 230
240 If A$="A" then goto 9910 else If A$="a" then goto 9910 ' Analog Test
250 If A$="D" then goto 410 else If A$="d" then goto 410' Digital Test
260 If A$="C" then goto 13300 else If A$="c" then goto 13300 ' Count Input Test
270 If A$="F" then goto 11510 else If A$="f" then goto 11510' Frequency Input Test
280 If A$="P" then goto 12410 else If A$="p" then goto 12400 ' Period Input Test
290 If A$="S" then goto 4110 else If A$="s" then goto 4110' Simple LED Chase
300 If A$="B" then goto 5010 else If A$="b" then goto 5010 ' Binary LED Count
310 If A$="G" then goto 7710 else If A$="g" then goto 7710' Bar Graph Display
320 If A$="L" then goto 9310 else If A$="l" then goto 9310 ' LED Cross Over
330 If A$="H" then goto 410 else If A$="h" then goto 410' Digital Tests
340 If A$="I" then goto 410 else If A$="i" then goto 3000' Information
360 goto 230 ' Invalid key pressed




410 ' Digital I/O Test
420 CLS
450 Print"           Digital I/O Test":Print
510 PRINT: PRINT"This will read the status of all 20 IO lines and"
610 PRINT"light the LEDs to reflect each switch position.":Print
710 PRINT"It will also display the status of ALL switches"
810 PRINT"on the USB Console (and Video on Maximite ONLY)"
910 PRINT:Print:Print:Print"         Press any key to start - ":Print
1010 PRINT" Then press any key to return to the MAIN MENU"
1110 a$=INKEY$: IF a$="" THEN GOTO 1110
1120 cnt=0:cls:Print"Toggle any switch - Press any key for MAIN MENU":Print
1130 Print"   Status:  Switch 1-20    (0=ON 1=OFF)":Print
1310 FOR pin_no=1 TO 20
1410 SETPIN pin_no,2 :pin_dat(pin_no)=PIN(pin_no)
1510 PRINT pin_dat(pin_no);:If pin_no=10 then Print" -";
1610 NEXT
1710 FOR pin_no=1 TO 20
1810 SETPIN pin_no,8 :PIN(pin_no)=pin_dat(pin_no)
2110 NEXT : PRINT
2210 PAUSE 1000
2220 cnt=cnt+1: if cnt=13 then goto 1120
2310 a$=INKEY$: IF a$="" THEN GOTO 1310 else goto 110




3000 cls:Print"          Test-A-Mite":Print
3010 Print"The Test-A-Mite has come about due to a discussion"
3020 Print"that first appeared on `The Back Shed' forum about"
3030 Print"how to test that all of the pins on the Maximite"
3040 Print"are working correctly and that there are no "
3050 Print"manufacturing faults on the PCB, as was becoming a"
3055 Print"fairly common event. Of course most Maximites are "
3060 Print"made from kits and some even from home brew PCBs.":print
3070 Print"Whilst I was pondering this it occurred to me that"
3080 Print"we could also use this on the Duinomite to show "
3085 Print"that all 20 GPIO pins are in fact usable and that"
3090 Print"the sharing of certain pins does not necessarilly"
3100 Print"mean that we cannot use all of them in real life.":Print
3101 Print"Press any key to continue   M - Return to menu"
3102 a$=INKEY$: IF a$="" THEN GOTO 3102 else goto 3103
3103 If A$="M" then goto 110 else If A$="m" then goto 110 ' Main Menu
3110 cls:Print"I also designed it to show that both genre's"
3120 Print"of `mite are similar, not the same, but close "
3130 Print"enough to be called brothers or cousins. I also"
3135 Print"desire to reunite both camps with a better "
3137 Print"understanding of each other's needs and wants and"
3140 Print"maybe a formal agreement on `code sharing' for"
3150 Print"the benefit of all..  Ok Preacher's hat off.":Print
3160 Print"Press any key to continue   M - Return to menu"
3170 a$=INKEY$: IF a$="" THEN GOTO 3170 else goto 3180
3180 If A$="M" then goto 110 else If A$="m" then goto 110 ' Main Menu
3190 cls:Print"   Maximite:":Print
3200 Print"The Maximite needs no special treatment to use"
3210 Print"the Test-A-Mite as there are no shared I-O in "
3220 Print"its design. The program supports the maximite,"
3225 Print"providing that Maximite mode is enabled when "
3230 Print"the program prompts for which platform it is "
3235 Print"connected to. The Maximite will work regardless"
3240 Print"of whether it is communicating via the USB"
3250 Print"Console or PS-2 keyboard & VGA/Composite Monitor."
3260 Print"It will also run from either the SD card or the "
3265 Print"internal A: drive."
3270 Print
3280 Print"Press any key to continue   M - Return to menu"
3290 a$=INKEY$: IF a$="" THEN GOTO 3290 else goto 3300
3300 If A$="M" then goto 110 else If A$="m" then goto 110 ' Main Menu
3320 cls:Print"   Duinomite:":Print
3330 Print"The Duinomite, because of its shared pins, "
3335 Print"which I prefer to call multi-purpose  pins,"
3340 Print"requires a few compromises to enable all 20 I-O"
3350 Print"to be used with the Test-A-Mite. "
3360 Print: Print"	Disable SD card Access:":Print
3370 Print"Pin(8), Pin(9) & Pin(10) are shared with the SD"
3375 Print"card and as such requires the SD card to be"
3380 Print"disabled or these 3 pins will not be usable."
3405 Print"The program can still be run from the Internal "
3410 Print"A: Drive so this isn't as big an issue as it may"
3420 Print"first appear. Refer to the Test-A-Mite manual.":Print
3430 Print"Press any key to continue   M - Return to menu ";
3440 a$=INKEY$: IF a$="" THEN GOTO 3440 else goto 3450
3450 If A$="M" then goto 110 else If A$="m" then goto 110 ' Main Menu
3470 cls:Print"         Disable Video:":Print
3480 Print"Pin(19) and Pin(20) are shared with the Video,"
3490 Print"to use both of these all video must be disabled"
3500 Print"via the SETUP command. ":Print:Print"        Refer to the Test-A-Mite manual.":Print
3510 Print"It may be, that in a future version of DMBasic"
3520 Print"we will be able to do this via a command"
3530 Print"similar to the SDDISABLE/SDENABLE command":Print
3540 Print"Press any key to continue   M - Return to menu ";
3550 a$=INKEY$: IF a$="" THEN GOTO 3550 else goto 3560
3560 If A$="M" then goto 110 else If A$="m" then goto 110 ' Main Menu
3570 cls:Print"	        Duinomite Mega:"
3580 Print:Print"As the Mega is designed to have onboard RS-232"
3590 Print"(via the DB-9 connector), it shares this function"
3600 Print"with Pin(11) as Rx, the RS-232 to 3.3v converter"
3610 Print"chip is connected to Pin(11) via a 330 Ohm "
3620 Print"resistor, normally this can be `driven over by"
3630 Print"any signal applied to Pin(11) but due to the "
3640 Print"fact that the Test-A-Mite uses a weak pull up"
3650 Print"(10k Ohm) and Pull down (1k Ohm) as part of "
3660 Print"its design (to enable reading of the switch in"
3670 Print"Input mode and control of the LED in Output mode)"
3680 Print"the Test-A-Mite loses in the tug-of-war with the"
3690 Print"converter chip.  Refer to the Test-A-Mite manual.":Print
3700 Print"Press any key to Return to the Main Menu ";
3710 a$=INKEY$: IF a$="" THEN GOTO 3710 else goto 110





4110 ' Simple LED Chase
4115 Print:Print"    Simple LED Chase  -  Press any key for Menu";
4210 FOR pin_no=1 TO 20 : SETPIN pin_no,8 :NEXT pin_no
4310 FOR pin_no=1 TO 20
4410 PIN(pin_no)=1 : PAUSE 20: PIN(pin_no)=0
4510 NEXT pin_no
4610 FOR pin_no=20 TO 1 STEP -1
4710 PIN(pin_no)=1 : PAUSE 20: PIN(pin_no)=0
4810 NEXT pin_no
4910 a$=INKEY$: IF a$="" THEN GOTO 4310 else goto 110



5010 ' Binary Count
5020 Print:Print"    Binary Count  -  Press any key for Menu";
5110 FOR pin_no=1 TO 10 : SETPIN pin_no,8 :PIN(pin_no)=0 : NEXT pin_no
5210 FOR pin_no=11 TO 20 : SETPIN pin_no,8 :PIN(pin_no)=1 : NEXT pin_no
5310 FOR x=0 TO 2^10
5410 IF x AND &B0000000001 THEN PIN(1)=1 ELSE PIN(1)=0
5510 IF x AND &B0000000010 THEN PIN(2)=1 ELSE PIN(2)=0
5610 IF x AND &B0000000100 THEN PIN(3)=1 ELSE PIN(3)=0
5710 IF x AND &B0000001000 THEN PIN(4)=1 ELSE PIN(4)=0
5810 IF x AND &B0000010000 THEN PIN(5)=1 ELSE PIN(5)=0
5910 IF x AND &B0000100000 THEN PIN(6)=1 ELSE PIN(6)=0
6010 IF x AND &B0001000000 THEN PIN(7)=1 ELSE PIN(7)=0
6110 IF x AND &B0010000000 THEN PIN(8)=1 ELSE PIN(8)=0
6210 IF x AND &B0100000000 THEN PIN(9)=1 ELSE PIN(9)=0
6310 IF x AND &B1000000000 THEN PIN(10)=1 ELSE PIN(10)=0
6410 IF x AND &B1000000000 THEN PIN(20)=1 ELSE PIN(20)=0
6510 IF x AND &B0100000000 THEN PIN(19)=1 ELSE PIN(19)=0
6610 IF x AND &B0010000000 THEN PIN(18)=1 ELSE PIN(18)=0
6710 IF x AND &B0001000000 THEN PIN(17)=1 ELSE PIN(17)=0
6810 IF x AND &B0000100000 THEN PIN(16)=1 ELSE PIN(16)=0
6910 IF x AND &B0000010000 THEN PIN(15)=1 ELSE PIN(15)=0
7010 IF x AND &B0000001000 THEN PIN(14)=1 ELSE PIN(14)=0
7110 IF x AND &B0000000100 THEN PIN(13)=1 ELSE PIN(13)=0
7210 IF x AND &B0000000010 THEN PIN(12)=1 ELSE PIN(12)=0
7310 IF x AND &B0000000001 THEN PIN(11)=1 ELSE PIN(11)=0
7410 PAUSE 50
7510 a$=INKEY$: IF a$<>"" THEN  goto 110
7515 NEXT x
7610 GOTO 5310



7710 ' Bar Graph Display
7750 Print:Print"    Bar Graph Display  -  Press any key for Menu";
7810 FOR pin_no=1 TO 20 : SETPIN pin_no,8 :PIN(pin_no)=1:NEXT pin_no
7910 FOR pin_no=1 TO 20
8010 PIN(pin_no)=1 : PAUSE 20: PIN(pin_no)=0
8110 NEXT pin_no
8210 FOR pin_no=20 TO 1 STEP -1
8310 PIN(pin_no)=0 : PAUSE 20: PIN(pin_no)=1
8410 NEXT pin_no
8510 FOR pin_no=1 TO 20 :PIN(pin_no)=1:NEXT pin_no
8610 FOR pin_no=20 TO 1 STEP -1
8710 PIN(pin_no)=1 : PAUSE 20: PIN(pin_no)=0
8810 NEXT pin_no
8910 FOR pin_no=1 TO 20
9010 PIN(pin_no)=0 : PAUSE 20: PIN(pin_no)=1
9110 NEXT pin_no
9114 a$=INKEY$: IF a$="" THEN GOTO 7810 else goto 110


9310 ' LED Cross Over
9311 Print:Print"    LED Cross Over  -  Press any key for Menu";
9313 FOR pin_no=1 TO 20 : SETPIN pin_no,8 :PIN(pin_no)=0:NEXT pin_no
9410 FOR pin_no=1 TO 20
9510 PIN(pin_no)=1:PIN(21-pin_no)=1:PAUSE 20:PIN(pin_no)=0:PIN(21-pin_no)=0
9610 ' IF pin_no=10 THEN PAUSE 20
9615 a$=INKEY$: IF a$="" THEN GOTO 9710 else goto 110
9710 NEXT pin_no
9810 GOTO 9410



9910 ' Analog Tests
9920 If Duino=1 then Duino$="    " else Duino$=" "
9930 If Duino=1 then Duino_Cnt=6 else Duino_Cnt=10
10010 CLS: PRINT" This will Test the Analog INPUT pins (1-";
10020 If Duino=1 then Print"6)":Print
10030 If Duino=0 then Print"10)":Print
10110 PRINT"We can use Sw1-Sw";
10120 If Duino=1 then Print"6"; else Print"10";
10130 Print" to select one of two voltages":Print
10210 PRINT"Different LEDs will vary, but expect about 1.8V"
10310 PRINT"with the Switch OFF and .29v with the Switch ON."
10410 PRINT"":Print
10460 If Duino=1 then Print"For Duinomite Only, Pin(5) and Pin(6) have pull"
10465 If Duino=1 then Print"up resistors that alter the Test-A-Mite's"
10470 If Duino=1 then Print"Voltage divider, expect 1.9v and .79v on these."
10480 If Duino=1 then Print:Print"      See Information on the Main Menu"
10510 PRINT: PRINT"      Press any key to start the test"
10710 PRINT:PRINT" Press any key to stop and go to the MAIN MENU ";
10910 a$=INKEY$: IF a$="" THEN 10910 
10960 cls:PRINT"Toggle Sw-1 to Sw-";
10970 If Duino=1 then Print"6"; else Print"10";
10975 Print" to alter Input Voltage":Print
10980 If Duino=1 then Print "Pin(1)  Pin(2)  Pin(3)  Pin(4)  Pin(5)  Pin(6)":Print
10990 If Duino=0 then Print "P(1) P(2) P(3) P(4) P(5) P(6) P(7) P(8) P(9) P(10)":Print
11010 FOR pin_no=1 TO Duino_Cnt: SETPIN Pin_no,1 : NEXT pin_no:Cnt=0
11110 FOR pin_no=1 TO Duino_Cnt: PRINT right$(format$(INT(100 * PIN(Pin_no))/100,"%+.2f"),4);Duino$; : NEXT pin_no
11210 PRINT:cnt=cnt+1:If cnt=13 then goto 10960
11310 PAUSE 1000
11410 a$=INKEY$: IF a$="" THEN GOTO 11110 ELSE GOTO 110





11510 if Duino=0 then goto 11640
11520 ' Frequency Tests   --- Duinomite
11530 x=0
11540 SETPIN 1,8:SETPIN 5,3:SETPIN 6,3 :SETPIN 7,3
11550 cls:cnt=0 : Print"           Frequency Input Test.":Print"Note! Expect a correct read to be 150-250Hz":Print
11560 Print"Place a Link on P(5), P(6) or P(7)"
11570 Print 
11580 PIN(1)=NOT(x)
11590 a$=INKEY$: IF a$="" THEN GOTO 11600 else goto 110
11600 cnt=cnt+1:if cnt=1200 then goto 11550
11610 if cnt/100 = int(cnt/100) then PRINT"Pin(5) = "; PIN(5);"Hz  Pin(6) = ";PIN(6);"Hz  Pin(7) = ";PIN(7);"Hz"
11620 x=NOT(x)
11630 GOTO 11580

11640 ' Frequency Tests  --- Maximite 
11650 x=0
11660 SETPIN 1,8:SETPIN 11,3:SETPIN 12,3 :SETPIN 13,3 :SETPIN 14,3
11670 cls:cnt=0 : Print"           Frequency Input Test.":Print"Note! Expect a correct read to be 150-250Hz":Print
11680 Print"Place a Link on P(11), P(12), P(13) or P(14)"
11690 Print
11700 PIN(1)=NOT(x)
11710 a$=INKEY$: IF a$="" THEN GOTO 11720 else goto 110
11720 cnt=cnt+1:if cnt=1200 then goto 11670
11730 if cnt/100 = int(cnt/100) then PRINT"P(11)="; PIN(11);"Hz  P(12)=";PIN(12);"Hz  P(13)=";PIN(13);"Hz  P(14)=";PIN(14);"Hz"
11740 x=NOT(x)
11750 GOTO 11700








12400 if Duino=0 then goto 13020
12405 ' Period Tests   --- Duinomite
12410 x=0
12510 SETPIN 1,8:SETPIN 5,4:SETPIN 6,4 :SETPIN 7,4
12550 cls:cnt=0 : Print"         Period Input Test.":Print"Note! Expect a correct read to be about 4-7ms":Print
12560 Print"Place a Link on P(5), P(6) or P(7)"
12570 Print 
12610 PIN(1)=NOT(x)
12710 a$=INKEY$: IF a$="" THEN GOTO 12720 else goto 110
12720 cnt=cnt+1:if cnt=1200 then goto 12510
12810 if cnt/100 = int(cnt/100) then PRINT"Pin(5) = "; PIN(5);"ms    Pin(6) = ";PIN(6);"ms    Pin(7) = ";PIN(7);"ms"
12910 x=NOT(x)
13010 GOTO 12610

13020 ' Period Tests  --- Maximite 
13030 x=0
13040 SETPIN 1,8:SETPIN 11,4:SETPIN 12,4 :SETPIN 13,4 :SETPIN 14,4
13050 cls:cnt=0 : Print"         Period Input Test.":Print"Note! Expect a correct read to be about 4-7ms":Print
13060 Print"Place a Link on P(11), P(12), P(13) or P(14)"
13070 Print
13090 PIN(1)=NOT(x)
13100 a$=INKEY$: IF a$="" THEN GOTO 13120 else goto 110
13120 cnt=cnt+1:if cnt=1200 then goto 13040
13130 if cnt/100 = int(cnt/100) then PRINT"P(11)="; PIN(11);"ms  P(12)=";PIN(12);"ms  P(13)=";PIN(13);"ms  P(14)=";PIN(14);"ms"
13140 x=NOT(x)
13150 GOTO 13090




13300 if Duino=0 then goto 14310
13310 ' Count Tests   --- Duinomite
13410 x=0
13510 SETPIN 1,8:SETPIN 5,5:SETPIN 6,5 :SETPIN 7,5
13550 cls:cnt=0 : Print"        Count Input Test.":Print"Note! Each PAGE should count incrementing by 50.":Print
13560 Print"Place a Link on P(5), P(6) or P(7)"
13570 Print 
13610 PIN(1)=NOT(x)
13710 a$=INKEY$: IF a$="" THEN GOTO 13720 else goto 110
13720 cnt=cnt+1:if cnt=1200 then goto 13550
13810 if cnt/100 = int(cnt/100) then PRINT"PIN(5) = "; PIN(5);"    Pin(6) = ";PIN(6);"    Pin(7) = ";PIN(7)
13910 x=NOT(x)
14010 GOTO 13610

14310 ' Count Tests  --- Maximite 
14410 x=0
14510 SETPIN 1,8:SETPIN 11,5:SETPIN 12,5 :SETPIN 13,5 :SETPIN 14,5
14550 cls:cnt=0 : Print"        Count Input Test.":Print"Note! Each PAGE should count incrementing by 50.":Print
14560 Print"Place a Link on P(11), P(12), P(13) or P(14)"
14570 Print
14610 PIN(1)=NOT(x)
14710 a$=INKEY$: IF a$="" THEN GOTO 14720 else goto 110
14720 cnt=cnt+1:if cnt=1200 then goto 14550
14810 if cnt/100 = int(cnt/100) then PRINT"P(11)="; PIN(11);"  P(12)=";PIN(12);"  P(13)=";PIN(13);"  P(14)=";PIN(14)
14910 x=NOT(x)
15010 GOTO 14610




